﻿@page "/Project"
@using Microsoft.Extensions.Localization
@using OTaskForce.Shared.Modals
@using OTaskForce.Shared.ProjectEditing
@using OTaskForce.Singletons
@using ElectronNET.API

@inject NavigationManager _navigationManager
@inject IStringLocalizer<Project> _localizer
@inject ProjectsOperator _projectsOperator

<style>
  nav div.nav.nav-tabs button.nav-link:hover,
  nav div.nav.nav-tabs button.nav-link.active
  { color:  #fe6700 !important; }
</style>

<section class="position-absolute d-flex flex-column" style="top: 0; bottom: 0; left: 0; right: 0;">
  <nav>
    <div class="nav nav-tabs">
      @* Main menu *@
      <button class="nav-link text-dark active" data-bs-toggle="tab" data-bs-target="#nav-overview">
        <i class="fas fa-campground"></i>
        <span>@_localizer["Огляд"]</span>
      </button>
      
      <button class="nav-link text-dark" data-bs-toggle="tab" data-bs-target="#nav-task-info">
        <i class="fas fa-tasks"></i>
        <span>@_localizer["Основна інформація"]</span>
      </button>
      
      <button class="nav-link text-dark" data-bs-toggle="tab" data-bs-target="#nav-task-description">
        <i class="fas fa-envelope-open-text"></i>
        <span>@_localizer["Умови завдання"]</span>
      </button>
      
      <button class="nav-link text-dark" data-bs-toggle="tab" data-bs-target="#nav-verification-data">
        <i class="fas fa-cube"></i>
        <span>@_localizer["Процес тестування"]</span>
      </button>
      @* /Main menu *@
      
      @* Right-sided menu *@
      <button class="nav-link text-dark ms-auto" @onclick="(async () => await OpenProjectFolderAsync())">
        <i class="fas fa-folder-open"></i>
        <span>@_localizer["Провідник"]</span>
      </button>
      
      <button class="nav-link text-dark" data-bs-toggle="modal" data-bs-target="#ExportTaskModal">
        <i class="fas fa-file-export"></i>
        <span>@_localizer["Експорт"]</span>
      </button>

      <button class="nav-link text-dark" @onclick="CloseProject">
        <i class="fas fa-door-closed"></i>
        <span>@_localizer["Вийти"]</span>
      </button>
      
      <button class="nav-link text-dark" data-bs-toggle="modal" data-bs-target="#AboutProgramModal"><i class="fas fa-info-circle"></i></button>
      @* /Right-sided menu *@
    </div>
  </nav>
  <div class="tab-content flex-grow-1">
    @* Project overview tab *@
    <div class="tab-pane fade show active h-100" id="nav-overview">
      <div class="position-relative h-100">
        <ProjectOverviewPanel/>
      </div>
    </div>
    @* /Project overview tab *@
    
    @* Project properties edit tab *@
    <div class="tab-pane fade h-100" id="nav-task-info">
      <div class="position-relative h-100">
        <ProjectPropertiesEditor/>
      </div>
    </div>
    @* /Project properties edit tab *@
    
    @* Task description tab *@
    <div class="tab-pane fade h-100" id="nav-task-description">
      <div class="position-relative h-100">
        <ProjectDescriptionEditor/>
      </div>
    </div>
    @* /Task description tab *@
    
    @* Verification data edit tab *@
    <div class="tab-pane fade h-100" id="nav-verification-data">
      <div class="position-relative h-100">
        <VerificationDataEditor/>
      </div>
    </div>
    @* /Verification data edit tab *@
  </div>
</section>

<ExportTaskModal/>

@code {
  protected override void OnInitialized()
  {
    if (!_projectsOperator.CurrentProjectControl.HasProjectOpened)
    {
      _navigationManager.NavigateTo("/");
      // ReSharper disable once RedundantJumpStatement
      return;
    }
  }

  private async Task OpenProjectFolderAsync()
  {
    await Electron.Shell.OpenPathAsync(_projectsOperator.CurrentProjectControl.ProjectDirectoryFullPath);
  }
  
  private void CloseProject()
  {
    _projectsOperator.CurrentProjectControl.CloseProject();
    _navigationManager.NavigateTo("/");
  }
}